﻿using System;
using System.Collections.ObjectModel;
using System.IO;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace ConsoleApplication1
{
    class Program
    {
        static WinformsMap winformsMap1 = new WinformsMap();

        static void Main(string[] args)
        {
            //******************************
            // Serialize
            //******************************

            for (int j = 0; j < 11; j++)
            {
                LayerOverlay overlay = new LayerOverlay();

                for (int i = 0; i < 2000; i++)
                {
                    InMemoryFeatureLayer inMemoryLayer = new InMemoryFeatureLayer();
                    inMemoryLayer.InternalFeatures.Add("Polygon", new Feature(BaseShape.CreateShapeFromWellKnownData("POLYGON((10 60,40 70,30 85, 10 60))")));
                    inMemoryLayer.InternalFeatures.Add("Multipoint", new Feature(BaseShape.CreateShapeFromWellKnownData("MULTIPOINT(12 20, 30 20,40 20, 12 30, 30 30, 40 30)")));
                    inMemoryLayer.InternalFeatures.Add("Line", new Feature(BaseShape.CreateShapeFromWellKnownData("LINESTRING(60 60, 70 70,75 60, 80 70, 85 60,95 80)")));
                    inMemoryLayer.InternalFeatures.Add("Rectangle", new Feature(new RectangleShape(65, 30, 90, 15)));

                    inMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.FillSolidBrush.Color = GeoColor.FromArgb(100, GeoColor.StandardColors.RoyalBlue);
                    inMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultAreaStyle.OutlinePen.Color = GeoColor.StandardColors.Blue;
                    inMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultLineStyle.OuterPen = new GeoPen(GeoColor.FromArgb(200, GeoColor.StandardColors.Red), 5);
                    inMemoryLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle.SymbolPen = new GeoPen(GeoColor.FromArgb(255, GeoColor.StandardColors.Green), 8);
                    inMemoryLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20;

                    inMemoryLayer.Open();
                    overlay.Layers.Add(inMemoryLayer);
                }
                winformsMap1.Overlays.Add(overlay);
            }

            GeoSerializer geoSerializer = new GeoSerializer();
            geoSerializer.Serialize(winformsMap1.Overlays, new FileStream("result.txt", FileMode.Create, FileAccess.ReadWrite, FileShare.ReadWrite));

            // **********************************
            // Deserialize
            // ************************************
            GeoSerializer serilizer = new GeoSerializer();

            using (FileStream stream = File.Open("result.txt", FileMode.Open))
            {
                object obj = serilizer.Deserialize(stream);
            }
        }
    }
}
